from summit.multiview_platform.monoview_classifiers.additions.SVCClassifier import \
    SVCClassifier

from ..monoview.monoview_utils import BaseMonoviewClassifier
from summit.multiview_platform.utils.hyper_parameter_search import CustomUniform

# Author-Info
__author__ = "Baptiste Bauvin"
__status__ = "Prototype"  # Production, Development, Prototype

classifier_class_name = "SVMRBF"


class SVMRBF(SVCClassifier, BaseMonoviewClassifier):
    """
    This class is an adaptation of scikit-learn's `SVC <https://scikit-learn.org/stable/modules/generated/sklearn.svm.SVC.html>`_

    Here, it is the RBF kernel version
    """

    def __init__(self, random_state=None, gamma="auto", C=1.0, **kwargs):
        SVCClassifier.__init__(self,
                               C=C,
                               kernel='rbf',
                               gamma=gamma,
                               random_state=random_state
                               )
        self.param_names = ["C", 'gamma', "random_state"]
        self.distribs = [CustomUniform(loc=1e-3, state=1e3), CustomUniform(loc=1e-1, state=1e1),  [random_state]]
