import os
import shutil
import mmap
import re


def simplify_plotly(html_file_path, level=0):
    arb = ['../' for _ in range(level)]
    print(html_file_path)
    with open(html_file_path, 'r') as html_file:
        file_string = html_file.read()
        new_str = re.sub(r'\<script type\="text/javascript"\>/\*\*(\n|.)*?27\)\}\)\);\</script\>', '<script src="{}plotly_js.js"></script>'.format("".join(arb)), file_string)
        with open(os.path.join(os.path.dirname(html_file_path), "compressed_"+os.path.basename(html_file_path)), 'w') as new_html:
            new_html.write(new_str)
    os.remove(html_file_path)


def explore_files(exp_path, level=0, compress=False):
    if level==0:
        shutil.copyfile('plotly_js.js', os.path.join(exp_path, "plotly_js.js"))

    for name in os.listdir(exp_path):
        new_path = os.path.join(exp_path, name)
        if name.endswith('.html') and not name.startswith("compressed_"):
            try:
                simplify_plotly(new_path, level=level)
            except:
                pass
        if os.path.isdir(new_path):
            explore_files(new_path, level=level+1)
    if level ==  0 and compress:
        shutil.make_archive(exp_path, 'zip', exp_path)
        os.rmdir(exp_path)


def remove_compressed(exp_path):
    for name in os.listdir(exp_path):
        new_path = os.path.join(exp_path, name)
        if name.startswith("compressed_") or name.endswith("_c.html") or name.endswith('_js.js'):
            os.remove(new_path)
        if os.path.isdir(new_path):
            remove_compressed(new_path)


if __name__=="__main__":
    for dir in os.listdir("/home/baptiste/Documents/Gitwork/summit/results/"):
        if os.path.isdir(os.path.join("/home/baptiste/Documents/Gitwork/summit/results/", dir)):
            for exp in os.listdir((os.path.join("/home/baptiste/Documents/Gitwork/summit/results/", dir))):
                print("\t", exp)
                if os.path.isdir(os.path.join("/home/baptiste/Documents/Gitwork/summit/results/", dir, exp)):
                    explore_files(os.path.join("/home/baptiste/Documents/Gitwork/summit/results/", dir, exp))
    plif = dict()
    # for dir in os.listdir("/home/baptiste/Documents/Clouded/short_projects/SCMBoost/results"):
    #     print(dir)
    #     for exp in os.listdir((os.path.join("/home/baptiste/Documents/Clouded/short_projects/SCMBoost/results", dir))):
    #         print("\t", exp)
    #         if os.path.isdir(os.path.join("/home/baptiste/Documents/Clouded/short_projects/SCMBoost/results", dir, exp)):
    #             explore_files(os.path.join("/home/baptiste/Documents/Clouded/short_projects/SCMBoost/results", dir, exp))
    # # explore_files("/home/baptiste/Documents/Gitwork/biobanq_covid_expes/results/")
    # explore_files("/home/baptiste/Documents/Gitwork/summit/results/clinical/debug_started_2023_04_05-08_23_00_bal_acc")
    # explore_files(
    #     "/home/baptiste/Documents/Gitwork/summit/results/lives_thesis_EMF/debug_started_2023_03_24-10_02_21_thesis")
    # # simplify_plotly("/home//baptiste/Documents/Gitwork/summit/results/hepatitis/debug_started_2022_03_16-15_06_55__/hepatitis-mean_on_10_iter-balanced_accuracy_p.html")
